

class GPIODriver {

  constructor(){
    const Gpio = require('pigpio').Gpio;
  }

  
  init() {
    return this.initBoard(0x20)
  }
  
  
  initBoard(address){
    let options = {
      i2c: i2cBus.openSync(1),
      address: address,
      frequency: 200,
      debug: false
    };
    
    return new Promise(
      (resolve, reject) => {
        console.log("beforeRealInit")
        this.pwm = new Pca9685Driver(options, function (err) {
          if (err) {
            reject("Failed to initialize boards");
          } else {
            console.log("in")
            resolve();
          }
        });
      });
  }


  /**
   * 
   * @param {*} channel channel to set
   * @param {*} value Between 0&256
   */
  setChannel(board,channel, value) {
    this.pwm.setPulseRange(channel, 0, (value * 16))
  }

  setRGB(channelConfig, colors) {
    channelConfig.forEach(channel => {
      this.setChannel(channel.address, channel.channel, channel.color)
      //console.log(`Setting channel ${channel.channel} on board ${channel.address} to ${colors[channel.color]}. `)  
    });
  }

}

module.exports = GPIODriver
