var i2cBus
var Pca9685Driver
    

class I2CDriver {
  

  constructor(address){
    this.address = address
    i2cBus = require("i2c-bus")
    Pca9685Driver = require("pca9685").Pca9685Driver
  }

  init() {
    return this.initBoard()
  }
  
  
  initBoard(){
    let options = {
      i2c: i2cBus.openSync(1),
      address: this.address,
      frequency: 200,
      debug: false
    };
    
    return new Promise(
      (resolve, reject) => {
        console.log("beforeRealInit")
        this.pwm = new Pca9685Driver(options, function (err) {
          if (err) {
            reject("Failed to initialize boards");
          } else {
            console.log("in")
            resolve();
          }
        });
      });
  }


  /**
   * 
   * @param {*} channel channel to set
   * @param {*} value Between 0&256
   */
  setChannel(channel, value) {
    console.log(`I2C: Set channel ${channel} on board ${this.address} to ${value}`)
    this.pwm.setPulseRange(channel, 0, (value * 16))
  }

 /* setRGB(channelConfig, colors) {
	console.log("set channel")
	console.log(channelConfig)
	console.log(colors)
    channelConfig.forEach(channel => {
      this.setChannel(channel.address, channel.channel, channel.color)
      console.log(`Setting channel ${channel.channel} on board ${channel.address} to ${colors[channel.color]}. `)  
    });
  } */

}

module.exports = I2CDriver
