var DummyDriver = require('./driver-dummy')
var I2CDriver = require('./driver-i2c')

class HardwareDriver {


  constructor(driver){
    this.driver = []
    this.driverType = driver

    
  }

  
  init(boards) {
    let promises = []
    boards.forEach(board=>{
      switch(this.driverType){
        case DRIVERTYPE.DUMMY:
          this.driver[board.boardID] = new DummyDriver(board.address)
          break
        case DRIVERTYPE.I2C:
          this.driver[board.boardID] = new I2CDriver(board.address)
          break
        case DRIVERTYPE.GPIO:
          console.log("GPIO not supported atm")
          //this.driver[board.boardID] = new GPIODriver()
          break
      }
      promises += this.driver[board.boardID].init()
    })
    return Promise.all(promises)
  }


  /**
   * 
   * @param {*} channel channel to set
   * @param {*} value Between 0&256
   */
  setChannel(board,channel, value) {
    this.driver[board].setChannel(channel, value)
  }

  setRGB(boardID, channelConfig, color) {
    console.log(channelConfig)
    console.log(color)
    channelConfig.forEach(channel => {
      this.setChannel(boardID, channel.channel, Math.round(color[channel.key]*color.a))
    });
  }

  

}

 const DRIVERTYPE = {
  DUMMY: 0,
  I2C: 1,
  GPIO: 2 
}

module.exports = {HardwareDriver, DRIVERTYPE}