CREATE TABLE IF NOT EXISTS `led`.`type` (
	`PK_type` INT NOT NULL AUTO_INCREMENT,
	`key` VARCHAR(20) NOT NULL,
    `name` VARCHAR(45),
    `description` VARCHAR(255),
    PRIMARY KEY (`PK_type`)
);

CREATE TABLE IF NOT EXISTS `led`.`board`(
	`PK_board`INT NOT NULL AUTO_INCREMENT,
    `address` VARCHAR(10),
    PRIMARY KEY (`PK_board`)
);

CREATE TABLE IF NOT EXISTS `led`.`preset` (
	`PK_preset` INT NOT NULL AUTO_INCREMENT,
    `title` VARCHAR(20),
    `description` VARCHAR(255),
    PRIMARY KEY (`PK_preset`)
);

CREATE TABLE IF NOT EXISTS `led`.`light` (
  `PK_light` INT NOT NULL AUTO_INCREMENT,
  `FK_type` INT NOT NULL,
  `name` VARCHAR(45) NOT NULL,
  `description` Varchar(255) NOT NULL,
  PRIMARY KEY (`PK_light`),
  FOREIGN KEY (`FK_type`) REFERENCES `led`.`type` (`PK_type`)
);

CREATE TABLE IF NOT EXISTS `led`.`mapping-light` (
	`PK_mapping-light`INT NOT NULL AUTO_INCREMENT,
    `FK_light`INT NOT NULL,
    `FK_board` INT NOT NULL,
    `channel`INT NOT NULL,
    `key` VARCHAR(10) NOT NULL,
    `description` VARCHAR(255),
    PRIMARY KEY (`PK_mapping-light`),
    FOREIGN KEY (`FK_light`) REFERENCES `led`.`light` (`PK_light`),
    FOREIGN KEY (`FK_board`) REFERENCES `led`.`board` (`PK_board`)
);

CREATE TABLE IF NOT EXISTS `led`.`mapping-preset` (
	`PK_mapping-preset` INT NOT NULL AUTO_INCREMENT,
    `FK_mapping-light` INT NOT NULL,
    `FK_mapping-preset` INT NOT NULL,
    PRIMARY KEY (`PK_mapping-preset`),
    FOREIGN KEY (`FK_mapping-light`) REFERENCES `led`.`mapping-light` (`PK_mapping-light`),
    FOREIGN KEY (`FK_mapping-preset`) REFERENCES `led`.`mapping-preset` (`PK_mapping-preset`)
);

INSERT INTO `type` VALUES(NULL, 'rgb', 'RGB', '3-Channel RGB stripe'),(NULL, 'switch','ON/OFF switch', '1-way ON/OFF switch');

INSERT INTO `board` VALUES(NULL, '0x40');

INSERT INTO `light` VALUES(NULL, 1, '1. Stripe', 'Absout erster Stripe'),(NULL, 1, '2. Stripe', 'Der zweite Stripe');

INSERT INTO `mapping-light` VALUES (NULL, 1, 1, 0, 'r', 'red'),(NULL, 1, 1, 1, 'g', 'green'),(NULL, 1, 1, 2, 'b', 'blue'),(NULL, 2, 1, 3, 'r', 'red'),(NULL, 2, 1, 4, 'g', 'green'),(NULL, 2, 1, 5, 'b', 'blue');